WATCH(1)

BEZEICHNUNG
watch - führt ein Programm in periodischen Abständen aus und zeigt die Ausgabe im Vollbild an

ÜBERSICHT
watch [Optionen] Befehl

BESCHREIBUNG
watch führt einen Befehl in periodischen Abständen aus und zeigt die Ausgabe sowie Fehlermeldungen im Vollbild an (der erste Bildschirminhalt). Dies ermöglicht Ihnen, die Änderungen eines Programms über einen bestimmten Zeitraum zu überwachen. Per Vorgabe wird das Programm alle 2 Sekunden ausgeführt, und watch läuft, bis es abgebrochen wird.

OPTIONEN

-d, --differences [permanent]
    hebt die Unterschiede zwischen aufeinanderfolgenden Aktualisierungen hervor. Optionale Argumente werden gelesen, die dafür sorgen, dass die Hervorhebung erhalten bleibt. Dies erlaubt Ihnen zu sehen, was sich mindestens seit dem ersten Durchlauf geändert hat.

-n, --interval Sekunden
    gibt das Aktualisierungsintervall an. Der Befehl erlaubt keine Aktualisierungen in weniger als 0.1 Sekunden Abstand. Kleinere Werte werden entsprechend umgewandelt.

-p, --precise
    ermöglicht watch zu versuchen, den Befehl im angegebenen Intervall (in Sekunden) auszuführen. Versuchen Sie dies mit ntptime und beachten Sie, wie die Sekundenbruchteile (beinahe) gleich bleiben, während sie sich im Normalmodus ständig erhöhen.

-t, --no-title
    schaltet die Anzeige der Kopfzeile ab, die das Intervall, den Befehl und die aktuelle Zeit im oberen Bereich des Bildschirms anzeigt, sowie die nachfolgende Leerzeile.

-b, --beep
    spielt einen Warnklang ab, wenn die Ausgabe des Befehls nicht Null ist.

-e, --errexit
    friert die Aktualisierungen bei Fehlern in der Befehlsausgabe ein und beendet nach Tastendruck.

-g, --chgexit
    beendet das Programm, wenn sich die Ausgabe des Befehls ändert.

-c, --color
    interpretiert ANSI-Farb- und Stilsequenzen.

-x, --exec
    Der Befehl wird an sh -c übergeben, was bedeutet, dass Sie zusätzliche Zitatzeichen verwenden müssen, um den gewünschten Effekt zu erzielen. Die Option --exec übergibt den Befehl direkt an exec(2).

-h, --help
    zeigt eine Hilfe an und beendet das Programm.

-v, --version
    zeigt Versionsinformationen an und beendet das Programm.

ANMERKUNG
Beachten Sie, dass die Optionen POSIX-konform verarbeitet werden (d.h. die Verarbeitung der Optionen stoppt bei der ersten Nicht-Option in der Befehlszeile). Dies bedeutet, dass Schalter nach dem Befehl von watch selbst nicht interpretiert werden.

BEISPIELE

Um nach Ihren Mails zu sehen, versuchen Sie

    watch -n 60 from

Um die Änderungen von Verzeichnisinhalten zu überwachen, verwenden Sie

    watch -d ls -l

Falls Sie nur an Dateien interessiert sind, die dem Benutzer »hans« gehören, verwenden Sie

    watch -d 'ls -l | fgrep hans'

Um die Wirkung von Zitatzeichen zu sehen, versuchen Sie

    watch echo $$
    watch echo '$$'
    watch echo "'"'$$'"'"

To see the effect of precision time keeping, try adding -p to

    watch -n 10 sleep 1

Sie können anzeigen lassen, wann der Administrator den neuesten Kernel installiert:

    watch uname -r

(Beachten Sie, dass -p nicht unbedingt nach einem Neustart des Systems funktioniert, speziell im Hinblick auf ntpdate oder anderen beim Systemstart die Zeit anpassenden Mechanismen.)

FEHLER
Nach der Größenänderung des Terminals wird der Bildschirm bis zur nächsten planmäßigen Aktualisierung nicht korrekt neu gezeichnet. Alle durch --differences verursachten Hervorhebungen gehen bei einer Aktualisierung ebenfalls verloren.

Nicht darstellbare Zeichen werden aus der Programmausgabe entfernt. Verwenden Sie »cat -v« als Teil der Befehlsweiterleitung, falls Sie diese sehen wollen.

Kombinationszeichen, die in der letzten Spalte angezeigt werden sollen, können eine Spalte eher angezeigt werden, oder überhaupt nicht.

Kombinationszeichen werden im --differences-Modus niemals als unterschiedliche Zeichen aufgefasst. Lediglich das Basiszeichen ist von Belang.

Leere Zeilen direkt nach einer Zeile, die in der letzten Spalte endet, werden nicht angezeigt.

--precise mode doesn't yet have advanced temporal distortion technology to compensate for a command that takes more than interval seconds to execute. watch also can get into a state where it rapid-fires as many executions of command as it can to catch up from a previous executions running longer than interval (for example, netstat taking ages on a DNS lookup).

EXIT-STATUS

    0   Erfolg.
    1   Verschiedene Fehler.
    2   Forken des zu überwachenden Prozesses ist fehlgeschlagen.
    3   Replacing child process stdout with write side pipe failed.
    4   Ausführung des Befehls ist fehlgeschlagen.
    5   Closing child process write pipe failed.
    7   Erstellung der IPC-Pipe ist fehlgeschlagen.
    8   Das Ermitteln des Rückgabewertes des Kindprozesses mit waitpid(2) ist fehlgeschlagen oder der Befehl wurde mit einem Fehler beendet.
    andere
        Die Überwachung propagiert den Exit-Status des Befehls als Exit-Status des Kindprozesses.

AUTOREN
Das originale watch wurde von Tony Rems (rembo@unisoft.com) im Jahre 1991 geschrieben, mit Modifizierungen und Korrekturen von Francois Pinard. Es wurde im Jahre 1999 von Mike Coleman (mkc@acm.org) überarbeitet, wobei auch neue Funktionen hinzugefügt wurden. Die beep- und exec-Funktionen sowie jene zur Fehlerbehandlung wurden von Morty Abzug (morty@frakir.org) im Jahre 2008 hinzugefügt. An einem nicht gar so dunklen und stürmischen Morgen im Jahre 2003 war Anthony DeRobertis (asd@suespammers.org) ganz krank von seinen Überwachungen, die nur in Minutenabständen aktualisierten, und baute die Mikrosekunden-Präzision ein. Unterstützung für Unicode wurde 2009 von Jarrod Lowe (procps@rrod.net) hinzugefügt.